"use strict";
//  BABYLON.SceneLoader.Append("https://rawgit.com/KhronosGroup/glTF-Sample-Models/master/2.0/Duck/glTF-Draco/", "Duck.gltf", scene, function (scene) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.Babylon = void 0;
// this file handles all the calls to BabylonJS
// specific shapes have functions defined in shapes.ts
// instructions from from a 'gameCmd' packet
// we don't know if we are player0 or one of the remotes
// although there may be thousands of BabylonJS entities, there
// is only one of us.  We store these shapes in ShapeMap
// import Ammo from '@hapi/ammo'
const babylonjs_1 = require("babylonjs");
const utilities_1 = require("../frontend/utilities");
const babylonjs_2 = require("babylonjs");
const babylonjs_3 = require("babylonjs");
const babylonjs_4 = require("babylonjs");
const babylonjs_materials_1 = require("babylonjs-materials");
const babylonjs_gui_1 = require("babylonjs-gui");
// import { SkyMaterial } from '@babylonjs/materials/sky'
// import { ThinEngine } from "@babylonjs/core/Engines/thinEngine"
const tween_1 = require("../middle/tween");
const babyengine_1 = require("../middle/babyengine");
const babything_1 = require("../frontend/babything");
const things_1 = require("./things");
const babylonjs_5 = require("babylonjs");
const consoleRed = 'background-color:red;color:white;';
const consoleYellow = 'background-color:yellow;color:black;';
const consoleBlue = 'background-color:blue;color:white;';
class Babylon {
    constructor(babyEngine) {
        this.isCameraSet = false; // if the user doesn't set a camera, then we have to
        this.playerNumber = 0; // eventually multiplayer
        // light2: HemisphericLight
        this.gravityVector = new babylonjs_1.Vector3(0, -9.81, 0);
        this.canvas = document.getElementById('renderCanvas');
        this.engine = new babylonjs_1.Engine(this.canvas, true);
        this.scene = new babylonjs_1.Scene(this.engine);
        this.scene.ambientColor = new babylonjs_1.Color3(0.3, 0.3, 0.3);
        // this.camera() //'arcRotate', this.origin, 20, 10, 20)   // default camera
        // this.camera = new ArcRotateCamera('Camera', 0, 0, 15, new Vector3(0, -5, 0), this.scene)
        // this.camera.setPosition(new Vector3(5, 20, -20))
        // this.camera.attachControl(this.canvas, true)       // attach the camera to the canvas
        this.babyEngine = babyEngine;
        // const light = new DirectionalLight('DirLight', new Vector3(0, -0.5, -1.0), this.scene)
        // light.position = new Vector3(20, 15, 70)
        // light.setDirectionToTarget(Vector3.Zero())
        // // light.position = new Vector3(-20, -15, -70)
        // var light2 = new DirectionalLight("dir02", new Vector3(-1, 0.5, 0), this.scene);
        // light2.position = new Vector3(0, -70, -70)
        // light2.setDirectionToTarget(Vector3.Zero())
        new babylonjs_3.HemisphericLight('HemiLight', new babylonjs_1.Vector3(0, 100, 100), this.scene);
        new babylonjs_3.HemisphericLight('HemiLight', new babylonjs_1.Vector3(0, -100, -100), this.scene);
        this.scene.ambientColor = new babylonjs_1.Color3(0.3, 0.3, 0.3);
        this.advancedTexture = babylonjs_gui_1.AdvancedDynamicTexture.CreateFullscreenUI('UI');
        this.enableAmmo();
        babyengine_1.BabyEngine.physicsViewer = new babylonjs_4.PhysicsViewer(this.scene);
        babyengine_1.BabyEngine.physicsHelper = new babylonjs_4.PhysicsHelper(this.scene);
        // this.physicsPlugin.setTimeStep(1)
        // this.physicsPlugin.setFixedTimeStep(1)
        // this.scene.enablePhysics(null, new BABYLON.AmmoJSPlugin());
        // var physicsEngine = scene.getPhysicsEngine();
        // physicsEngine.setSubTimeStep(100);
        this.scene.onKeyboardObservable.add((kbInfo) => {
            switch (kbInfo.type) {
                case BABYLON.KeyboardEventTypes.KEYDOWN:
                    // console.log("KEY DOWN: ", kbInfo.event.key);
                    babyengine_1.BabyEngine.notifyObservers('keydown', kbInfo.event);
                    break;
                case BABYLON.KeyboardEventTypes.KEYUP:
                    // console.log("KEY UP: ", kbInfo.event.key);
                    babyengine_1.BabyEngine.notifyObservers('keyup', kbInfo.event);
                    break;
            }
        });
        // this.scene.onPointerDown = function castRay() {
        //     var ray = this.scene.createPickingRay(this.scene.pointerX, this.scene.pointerY, Matrix.Identity(), this.camera);
        //     var hit = this.scene.pickWithRay(ray);
        //     console.log('HIT', hit.pickedMesh.name)
        // }
        // babylon pointer events
        this.scene.onPointerObservable.add((pointerInfo) => {
            switch (pointerInfo.type) {
                case BABYLON.PointerEventTypes.POINTERDOWN:
                    console.log("POINTER DOWN");
                    var ray = this.scene.createPickingRay(this.scene.pointerX, this.scene.pointerY, babylonjs_1.Matrix.Identity(), this.camera);
                    var hit = this.scene.pickWithRay(ray);
                    if (hit.pickedMesh !== null) { // did we hit a mesh?
                        babyengine_1.BabyEngine.shapeMap.forEach(shape => {
                            if (hit.pickedMesh === shape.babylonMesh) {
                                babyengine_1.BabyEngine.notifyObservers(`click.${shape.uuid}`);
                                console.log('notifying observer', `click.${shape.uuid}`);
                            }
                        });
                    }
                    break;
                case BABYLON.PointerEventTypes.POINTERUP:
                    console.log("POINTER UP");
                    break;
                case BABYLON.PointerEventTypes.POINTERMOVE:
                    // console.log("POINTER MOVE");
                    break;
                case BABYLON.PointerEventTypes.POINTERWHEEL:
                    console.log("POINTER WHEEL");
                    break;
                case BABYLON.PointerEventTypes.POINTERPICK:
                    console.log("POINTER PICK");
                    break;
                case BABYLON.PointerEventTypes.POINTERTAP:
                    console.log("POINTER TAP");
                    break;
                case BABYLON.PointerEventTypes.POINTERDOUBLETAP:
                    console.log("POINTER DOUBLE-TAP");
                    break;
            }
        });
        // get the render engine running...
        this.runRenderStep();
    }
    async enableAmmo() {
        // await Ammo()
        this.physicsPlugin = new babylonjs_4.AmmoJSPlugin();
        this.scene.enablePhysics(this.gravityVector, this.physicsPlugin);
    }
    createBabylonMesh(cmd, handle) {
        // babylon's inspector likes to have a unique name for each mesh
        // use default size, position, and orientation
        // physics types...
        //    PhysicsImpostor.SphereImpostor;
        //    PhysicsImpostor.BoxImpostor;
        //    PhysicsImpostor.PlaneImpostor;
        //    PhysicsImpostor.MeshImpostor;
        //    PhysicsImpostor.CylinderImpostor;
        //    PhysicsImpostor.ParticleImpostor;
        //    PhysicsImpostor.HeightmapImpostor;
        //    PhysicsImpostor.ConvexHullImpostor;
        // physics parameters...
        // export interface PhysicsImpostorParameters {
        //     mass: number;    // zero is good for floors
        //     friction?: number;
        //     restitution?: number;
        //     nativeOptions?: any;
        //     ignoreParent?: boolean;
        //     disableBidirectionalTransformation?: boolean;
        // }
        // let x = ammo // just making sure it gets imported
        // let y = AmmoJSPlugin
        // let f = fs.Stats //      "
        // eslint-disable-next-line @typescript-eslint/ban-types
        let gridMaterial; // because can't declare it in a switch
        let thing;
        switch (cmd.model) {
            case 'cube':
                thing = new things_1.Cube(cmd, handle, this.scene);
                break;
            case 'sphere':
                thing = new things_1.Sphere(cmd, handle, this.scene);
                break;
            case 'cylinder':
                thing = new things_1.Cylinder(cmd, handle, this.scene);
                break;
            case 'cone':
                thing = new things_1.Cone(cmd, handle, this.scene);
                break;
            case 'capsule':
                thing = new things_1.Capsule(cmd, handle, this.scene);
                break;
            case 'torus':
                thing = new things_1.Torus(cmd, handle, this.scene);
                break;
            case 'point': // really a VERY SMALL sphere, but colliders, etc still work
                thing = new things_1.Point(cmd, handle, this.scene);
                break;
            case 'vt52':
                thing = new things_1.VT52(cmd, handle, this.scene);
                break;
            case 'graph':
                thing = new things_1.GRAPH(cmd, handle, this.scene);
                break;
                // bottom = new TransformNode('tn.000', this.scene)
                // top = new TransformNode('tn.001', this.scene)
                // bottom.position = handle.babylonMesh.position
                // handle.babylonMesh.setParent(bottom)
                // top.position = handle.babylonMesh.position
                // handle.babylonMesh.setParent(top)
                break;
            case 'floor':
                thing = new things_1.Floor(cmd, handle, this.scene);
                break;
            default:
                console.assert(false, `Did not expect model '${cmd.model}'`);
                throw ('stop');
        }
        thing.handle.thing = thing; // assign the class into MeshHandle, for later
        // default values for a new entity
        // this.material.specularColor = new Color3(0.5, 0.6, 0.87)
        // this.material.emissiveColor = new Color3(1, 1, 1)
        // this.material.ambientColor = new Color3(0.23, 0.98, 0.53)
        // this.material.alpha = 0.5
        // console.log('%ccreating box', consoleYellow)
        if (thing.handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
            // otherwise mass is zero
            if (cmd.collider !== 'ghost') {
                thing.handle.collider = cmd.collider;
                let visible = this.scene.debugLayer.isVisible();
                thing.setupCollider();
                // only ACTIVE shapes get callbacks.  of course we could collide with another active shape
                if (cmd.collider == 'active') {
                    thing.handle.babylonMesh.physicsImpostor
                        .registerOnPhysicsCollide(babyengine_1.BabyEngine.impostors, (a, b) => {
                        this.onCollisionHelper(a, b);
                    });
                }
            }
        }
    }
    setCamera(cmd, handle) {
        // let position = new Vector3(5, cmd.heightOffset, -cmd.heightOffset)
        // let position = new Vector3(5, cmd.distance, -cmd.heightOffset)
        const position = new babylonjs_1.Vector3(5, 20, -20);
        // do we already have a camera
        if (this.isCameraSet) {
            this.scene.detachControl();
        }
        this.isCameraSet = true; // 
        console.log('cmd', cmd);
        switch (cmd.model) {
            // case 'orthocamera':
            //     // this.camera = new FreeCamera("camera1", new Vector3(0, 100, 0), this.scene);
            //     this.camera = new ArcRotateCamera('Camera', 0, 0, 15, new Vector3(0, -5, 0), this.scene)
            //     this.camera.setTarget(Vector3.Zero());
            //     // this.camera.attachControl();    //Not needed unless debuging in camera or for some other reason.            
            //     this.camera.mode = BABYLON.Camera.ORTHOGRAPHIC_CAMERA;
            //     this.camera.setPosition(new Vector3(0, 20, 0))
            //     break
            case 'fly':
            case 'follow':
            case 'universal':
            case 'arcRotate':
                // if (this.camera instanceof ArcRotateCamera) {  // typeguard
                // handle.babylonMesh = new ArcRotateCamera('Camera', 0, 0, 15, new Vector3(0, -5, 0), this.scene)
                // this.camera.setPosition(new Vector3(5, 20, -20))
                // handle.babylonMesh = this.camera
                let thing = new things_1.CameraThing(cmd, handle, this.scene);
                break;
                // // default camera
                // const camera = new ArcRotateCamera('Camera', 0, 0, 15, new Vector3(-0, -5, 0), this.scene)
                // camera.setPosition(new Vector3(5, 20, -20))
                // camera.minZ = 5.0
                // camera.attachControl(this.canvas, true)
                // case 'follow':
                //     this.camera = new FollowCamera("FollowCam", position, this.scene);
                //     this.camera.radius = cmd.distance
                //     this.camera.heightOffset = cmd.heightOffset
                //     // The goal rotation of camera around local origin (centre) of target in x y plane
                //     this.camera.rotationOffset = cmd.rotation  // in degrees?
                //     // Acceleration of camera in moving from current to goal position
                //     this.camera.cameraAcceleration = 0.05
                //     // The speed at which acceleration is halted
                //     this.camera.maxCameraSpeed = 10
                //     break
                break;
            default:
                console.error('%cdid not expect camera of type ' + cmd.cameraType, consoleRed);
        }
        // handle.babylonMesh = this.camera
        handle.type = 'camera';
    }
    //TODO: this doesn't work  // we attach controls in CameraThing, otherwise doesn't work
    attachControls(cmd, handle) {
        console.error(`%cattachControls() doesn't work`, consoleRed);
        let pos = handle.babylonMesh.position;
        handle.babylonMesh.dispose();
        let thing = new babylonjs_2.ArcRotateCamera('Camera', 0, 0, 15, new babylonjs_1.Vector3(0, 0, 0), this.scene);
        if (thing instanceof babylonjs_2.Camera) { // typeguard
            thing.setPosition(pos);
            thing.attachControl('', false); // attach the camera to the canvas
            thing.useAutoRotationBehavior = false;
        }
        handle.babylonMesh = thing;
        this.scene.setActiveCameraByName(handle.uniqueName);
    }
    setOrthographic(cmd, handle) {
        if (handle.babylonMesh instanceof babylonjs_2.Camera) { // typeguard
            handle.babylonMesh.mode = BABYLON.Camera.ORTHOGRAPHIC_CAMERA;
            handle.babylonMesh.orthoTop = cmd.size;
            handle.babylonMesh.orthoBottom = -cmd.size;
            handle.babylonMesh.orthoLeft = -cmd.size;
            handle.babylonMesh.orthoRight = cmd.size;
        }
        else {
            console.log('should be camera', handle);
            console.error('should be Camera');
        }
    }
    impostorLookup(a) {
        let result = null; // but we expect we will find it
        babyengine_1.BabyEngine.shapeMap.forEach((handle) => {
            if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                if (handle.babylonMesh.physicsImpostor === a)
                    result = handle;
            }
        });
        console.assert(result !== null, "how can we NOT find this impostor?");
        return result;
    }
    /** if Ammo tells us a collision happened, this cleans up and notifies the parties */
    onCollisionHelper(a, b) {
        if (a === b) { // sometimes we seem to collide with ourselves ?!?
            // console.log('%cA and B are === - we collided with ourself',consoleRed)
            return;
        }
        // lookup the uuid for a and b, and send BOTH a message
        let aMesh = null;
        let aMeshHandle = null;
        let bMesh = null;
        let bMeshHandle = null;
        babyengine_1.BabyEngine.shapeMap.forEach((mesh) => {
            if (mesh.babyShape instanceof babylonjs_1.Mesh) { // typeguard
                if (mesh.model == 'camera')
                    return; // no camera collisions yet
                if (mesh.model == 'button')
                    return; // no camera collisions yet
                // we only allow a shape to collide once every 100ms
                // console.log(mesh.babylonMesh.physicsImpostor)
                if (mesh.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                    if (typeof mesh.babylonMesh.physicsImpostor === 'object' &&
                        mesh.lastCollisionTime < (Date.now() - 10)) {
                        if (mesh.babylonMesh.physicsImpostor === a) {
                            aMesh = mesh.babyShape; // get the babyShape for this mesh
                            aMeshHandle = mesh;
                        }
                        if (mesh.babylonMesh.physicsImpostor === b) {
                            bMesh = mesh.babyShape;
                            bMeshHandle = mesh;
                        }
                    }
                }
            }
        });
        // ok, did we get TWO shapes?  (many reasons we might not)
        if (aMesh !== null && bMesh !== null) {
            // signal both that they hit each other... likely only one is listening
            babyengine_1.BabyEngine.notifyObservers(`collide.${aMesh.uuid}`, bMesh);
            babyengine_1.BabyEngine.notifyObservers(`collide.${bMesh.uuid}`, aMesh);
            // this is a small debounce.  neither will hit for 100th of a second
            aMeshHandle.lastCollisionTime = Date.now();
            bMeshHandle.lastCollisionTime = Date.now();
            // aMesh.collideCallback(bMesh) // set by .onCollide()
            // bMesh.collideCallback(aMesh)
        }
    }
    importShape(cmd, handle) {
        console.log('in importShape');
        throw ('in importShape');
        let babylonMesh;
        // The first parameter can be used to specify which mesh to import. Here we import all meshes
        babylonjs_1.SceneLoader.ImportMesh('', 'assets/', 'TinkerCraft.glb', this.scene, (newMeshes) => {
            console.log(newMeshes);
            babylonMesh = newMeshes[0];
        });
    }
    dispose(cmd, handle) {
        console.assert(typeof handle === 'object', "trying to dispose of something, but can't find it.  already gone?");
        handle.cleanBeforeDispose();
        handle.babylonMesh.dispose(); // gets rid of all the contents
        // but still have the handle around 
        // console.log('disposing of ', handle)
        babyengine_1.BabyEngine.shapeMap.delete(handle.uuid);
    }
    addSkeleton(cmd, handle) {
        console.log('addSkeleton');
    }
    attachTo(cmd, handle) {
        console.log('arrived in attache to');
        const otherHandle = babyengine_1.BabyEngine.shapeMap.get(cmd.otherUuid);
    }
    addAxes(cmd, handle) {
        const size = 2;
        const shade = 0;
        const pilot_local_axisX = babylonjs_1.Mesh.CreateLines('pilot_local_axisX', [
            babylonjs_1.Vector3.Zero(), new babylonjs_1.Vector3(-size, 0, 0), new babylonjs_1.Vector3(-size * 0.95, 0.05 * -size, 0),
            new babylonjs_1.Vector3(-size, 0, 0), new babylonjs_1.Vector3(-size * 0.95, -0.05 * -size, 0)
        ]);
        pilot_local_axisX.color = new babylonjs_1.Color3(1, shade, shade);
        const pilot_local_axisY = babylonjs_1.Mesh.CreateLines('pilot_local_axisY', [
            babylonjs_1.Vector3.Zero(), new babylonjs_1.Vector3(0, size, 0), new babylonjs_1.Vector3(-0.05 * size, size * 0.95, 0),
            new babylonjs_1.Vector3(0, size, 0), new babylonjs_1.Vector3(0.05 * size, size * 0.95, 0)
        ]);
        pilot_local_axisY.color = new babylonjs_1.Color3(shade, 1, shade);
        const pilot_local_axisZ = babylonjs_1.Mesh.CreateLines('pilot_local_axisZ', [
            babylonjs_1.Vector3.Zero(), new babylonjs_1.Vector3(0, 0, size), new babylonjs_1.Vector3(0, -0.05 * size, size * 0.95),
            new babylonjs_1.Vector3(0, 0, size), new babylonjs_1.Vector3(0, 0.05 * size, size * 0.95)
        ]);
        pilot_local_axisZ.color = new babylonjs_1.Color3(shade, shade, 1);
        // var local_origin = MeshBuilder.CreateBox("local_origin", {size:1});
        // local_origin.isVisible = false;
        pilot_local_axisX.parent = handle.babylonMesh;
        pilot_local_axisY.parent = handle.babylonMesh;
        pilot_local_axisZ.parent = handle.babylonMesh;
        // return local_origin;
    }
    collide(cmd, handle) {
        // in every case, if there are already impostors then remove them
        if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard, only shapes, not cameras or points
            if (handle.babylonMesh.physicsImpostor !== undefined) {
                // first step - remove the old impostor from the global list of impostors, and dispose of it
                babyengine_1.BabyEngine.impostors.splice(babyengine_1.BabyEngine.impostors.findIndex(e => {
                    if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                        e === handle.babylonMesh.physicsImpostor;
                    }
                }), 1);
                handle.babylonMesh.physicsImpostor.dispose();
            }
            if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                switch (cmd.collider) {
                    case 'ghost':
                        handle.babylonMesh.physicsImpostor = null; // doesn't really do anything
                        break;
                    case 'solid':
                    case 'active':
                        // TODO decide whether box or ball...
                        // TODO that's why we need a shape obect - abstractShapes.ts
                        handle.babylonMesh.physicsImpostor = new babylonjs_5.PhysicsImpostor(handle.babylonMesh, babylonjs_5.PhysicsImpostor.BoxImpostor, { mass: handle.mass, restitution: handle.restitution }, this.scene);
                        if (this.scene.debugLayer.isVisible()) {
                            babyengine_1.BabyEngine.physicsViewer.showImpostor(handle.babylonMesh.physicsImpostor);
                        }
                        // and push the new resized back on the global list of impostors
                        babyengine_1.BabyEngine.impostors.push(handle.babylonMesh.physicsImpostor);
                        // finally, register any hits against this shape
                        handle.babylonMesh.physicsImpostor.registerOnPhysicsCollide(babyengine_1.BabyEngine.impostors, (a, b) => {
                            this.onCollisionHelper(a, b);
                        });
                        break;
                    case 'active':
                        break;
                }
            }
            else
                console.error('collisions only for Mesh');
        }
    }
    setColor(cmd, handle) {
        // console.log(`setting ${handle.uuid} to ${cString}  ${color.toHexString()}`)
        // handle.material.dispose()   // let go of the old material
        // handle.material = new StandardMaterial('', this.scene)
        if (cmd.colorD !== '' && 'diffuseColor' in handle.material) { // not all colors have diffuseColor
            handle.material.diffuseColor = utilities_1.HTMLColor(cmd.colorD);
            handle.diffuseColor = utilities_1.HTMLColor(cmd.colorD); // for lines and stuff
        }
        if (cmd.colorA !== '' && 'ambientColor' in handle.material) { // not all colors have diffuseColor
            handle.material.ambientColor = utilities_1.HTMLColor(cmd.colorA);
        }
        if (cmd.colorE !== '' && 'emissiveColor' in handle.material) { // not all colors have diffuseColor
            handle.material.emissiveColor = utilities_1.HTMLColor(cmd.colorE);
        }
        if (cmd.colorS !== '' && 'specularColor' in handle.material) { // not all colors have diffuseColor
            handle.material.specularColor = utilities_1.HTMLColor(cmd.colorE);
        }
        // this.material.alpha = 0.5  // do we care?
        // handle.babylonMesh.material = handle.material
    }
    /// ///////////////////////////////////////////////////////
    // if you want to do old-school getPosition / setPosition, here it is
    /// ///////////////////////////////////////////////////////
    setPosition(cmd, handle) {
        handle.babylonMesh.position = new babylonjs_1.Vector3(cmd.x, cmd.y, cmd.z);
    }
    addToPosition(cmd, handle) {
        handle.babylonMesh.position = handle.babylonMesh.position.addInPlace(new babylonjs_1.Vector3(cmd.x, cmd.y, cmd.z));
    }
    setRotation(cmd, handle) {
        console.log('setRotation()', cmd);
        if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
            handle.babylonMesh.setDirection(new babylonjs_1.Vector3(cmd.x, cmd.y, cmd.z));
        }
        else {
            //TODO rotation for camera
            console.error('missing rotation for camera');
        }
    }
    addToRotation(cmd, handle) {
        if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
            handle.babylonMesh.rotation.x += cmd.x;
            handle.babylonMesh.rotation.y += cmd.y;
            handle.babylonMesh.rotation.z += cmd.z;
        }
        else {
            //TODO rotation for camera
            console.error('missing rotation for camera');
        }
    }
    /// ///////////////////////////////////////////////////////
    setScale(cmd, handle) {
        if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
            handle.babylonMesh.scaling = new babylonjs_1.Vector3(cmd.x, cmd.y, cmd.z);
        }
        else {
            console.error('setScale only for Mesh');
        }
    }
    // setGrid(gridRatio: number = 0.1, majorUnitFrequency: number = 2, lineColor: string = "White"): Entity {
    setGrid(cmd, handle) {
        const grid = new babylonjs_materials_1.GridMaterial('grid', this.scene);
        grid.gridRatio = cmd.gridRatio;
        grid.majorUnitFrequency = cmd.major;
        grid.mainColor = utilities_1.HTMLColor(cmd.colorD); // in case we set color before material
        grid.lineColor = utilities_1.HTMLColor(cmd.lineColor);
        handle.material.dispose(); // let go of the old material
        handle.gridMaterial = grid;
    }
    /// ////////////////////////////////
    ///  Alice Functions
    /// ////////////////////////////////
    // use ROTATION, not QUATERNION, then move in
    // forward / backward direction like so....
    // box.locallyTranslate(new BABYLON.Vector3(5,0 , 0));
    // box.locallyTranslate(new BABYLON.Vector3(-5,0 , 0));
    // to move in circle around a point, see https://doc.babylonjs.com/how_to/transformnode
    move(cmd, tween, handle) {
        console.assert(cmd !== undefined, 'cmd missing');
        console.assert(tween !== undefined, 'tween missing');
        console.assert(handle !== undefined, 'handle missing');
        // direction: 'forward' | 'backward' | 'left' | 'right' | 'up' | 'down',
        // distance: number,
        // duration = 1,
        // animate: "Begin And End Normally" | "Begin Slow, End Fast" | "Begin Fast, End Slow" | "Begin And End Fast" | "Begin And End Slow" = "Begin And End Normally") {
        // console.log('move()', handle.babylonMesh.position)
        const v = new babylonjs_1.Vector3(0, 0, 0);
        switch (cmd.direction) {
            case 'forward':
                v.x = -cmd.distance;
                break;
            case 'backward':
                v.x = cmd.distance;
                break;
            case 'left':
                v.z = cmd.distance;
                break;
            case 'right':
                v.z = -cmd.distance;
                break;
            case 'down':
                v.y = -cmd.distance;
                break;
            case 'up':
                v.y = cmd.distance;
                break;
            default:
                console.assert(false, `did not expect '${cmd.direction}'`);
        }
        // i could have created vNormal as v.divide(cmd.distance)
        // figure out where we would be by using a transform node
        // set it to the same position and orientation as the mesh
        // tNode.position = handle.babylonMesh.position.clone()
        // handle.babylonMesh.parent = tNode
        // tNode.setDirection(handle.babylonMesh.getDirection(Vector3.Zero()))
        // tNode.locallyTranslate(v)
        const tNode = new babylonjs_4.TransformNode('', this.scene, false); // don't add to scene
        let endPosition;
        let vNormal;
        let babylonThing;
        babylonThing = handle.babylonMesh;
        if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
            tNode.position = handle.babylonMesh.position.clone();
            tNode.setDirection(handle.babylonMesh.getDirection(babylonjs_1.Vector3.Zero()));
            tNode.locallyTranslate(v);
            endPosition = tNode.position;
            vNormal = tNode.position.clone().subtract(babylonThing.position).normalize();
            // v already has +/- distance on the axis, so axis should just be positive
            vNormal.x = Math.abs(vNormal.x) * (1 / handle.babylonMesh.scaling.x);
            vNormal.y = Math.abs(vNormal.y) * (1 / handle.babylonMesh.scaling.y);
            vNormal.z = Math.abs(vNormal.z) * (1 / handle.babylonMesh.scaling.z);
        }
        else {
            endPosition = babylonThing.position.clone().add(v); // can't use tNode for camera
        }
        // move() has to work for meshs, cameras, and lights, but only shapes has scaling
        // console.log('moving from ', babylonThing.position, ' to ', tNode.position)
        console.assert(babylonThing.position instanceof babylonjs_1.Vector3, 'Expecting a Vector3 at Move()');
        // console.log(`%c tween.start ${handle.type}`, consoleRed, handle.babylonMesh.position, endPosition,handle)
        tween.start('move', babylonThing.position.clone(), // start
        endPosition, // end
        cmd.timestamp, cmd.duration, cmd.animate, (value) => {
            // in 'local space', distances depend on your scaling
            // we translate them back to world-relative distances
            if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                value.x *= (1 / handle.babylonMesh.scaling.x);
                value.y *= (1 / handle.babylonMesh.scaling.y);
                value.z *= (1 / handle.babylonMesh.scaling.z);
                // console.log(handle.uuid,'value',value,'vNormal',vNormal)
                handle.babylonMesh.translate(vNormal, value.x, babylonjs_1.Space.LOCAL);
                handle.babylonMesh.translate(vNormal, value.y, babylonjs_1.Space.LOCAL);
                handle.babylonMesh.translate(vNormal, value.z, babylonjs_1.Space.LOCAL);
                handle.maybeAddLineSegment(); // if penDown, then need a line
            }
            else {
                // there's something horrible going on with typescript's type system
                let newPosition = handle.babylonMesh.position.clone().add(value);
                let c = handle.babylonMesh;
                c.setPosition(newPosition);
                // console.log('%cMoving Camera, now at', consoleBlue, handle.babylonMesh.position)
            }
        });
        tNode.dispose();
    }
    moveToward(cmd, tween, handle) {
        // otherUuid: number
        // distance: number,
        // duration = 1,
        // animate: "Begin And End Normally" | "Begin Slow, End Fast" | "Begin Fast, End Slow" | "Begin And End Fast" | "Begin And End Slow" = "Begin And End Normally") {
        // get direction towards babylonjs entity that we are moving toward
        const otherHandle = babyengine_1.BabyEngine.shapeMap.get(cmd.otherUuid);
        const axis = otherHandle.babylonMesh.position.clone().subtract(handle.babylonMesh.position);
        // now calculate our endpoint
        const tNode = new babylonjs_4.TransformNode('', this.scene, false); // don't add to scene
        tNode.position = otherHandle.babylonMesh.position.clone();
        tNode.translate(axis.normalize(), cmd.distance, babylonjs_1.Space.WORLD);
        tween.start('move', handle.babylonMesh.position.clone(), // start
        otherHandle.babylonMesh.position.clone(), //tNode.position.clone(), // end
        cmd.timestamp, cmd.duration, cmd.animate, (value) => {
            handle.babylonMesh.position.x += value.x;
            handle.babylonMesh.position.y += value.y;
            handle.babylonMesh.position.z += value.z;
        });
        tNode.dispose();
    }
    moveToZero(cmd, tween, handle) {
        let start = handle.babylonMesh.position.clone();
        tween.start('move', start, // start
        new babylonjs_1.Vector3(0, 0, 0), // end
        cmd.timestamp, cmd.duration, cmd.animate, (value) => {
            if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                handle.babylonMesh.position.x += value.x;
                handle.babylonMesh.position.y += value.y;
                handle.babylonMesh.position.z += value.z;
            }
            else {
                handle.babylonMesh.position.addInPlace(value);
                // handle.babylonCamera.position.x += value.x
                // handle.babylonCamera.position.y += value.y
                // handle.babylonCamera.position.z += value.z
            }
        });
    }
    // standard setup tween handler for all the 'move' commands
    moveSetupTween(cmd, tween, handle, start, end) {
        // console.log(`moveSetupTween()`, start, end)
        tween.start('move', start, end, cmd.timestamp, cmd.duration, cmd.animate, (value) => {
            // handle.babylonMesh.translate(new Vector3(1, 0, 0), value.x, Space.WORLD)
            // handle.babylonMesh.translate(new Vector3(0, 1, 0), value.y, Space.WORLD)
            // handle.babylonMesh.translate(new Vector3(0, 0, 1), value.z, Space.WORLD)
            handle.babylonMesh.position.x += value.x;
            handle.babylonMesh.position.y += value.y;
            handle.babylonMesh.position.z += value.z;
            // console.log('delta ',handle.uuid,value)
        });
    }
    turn(cmd, tween, handle) {
        // towards: 'forward' | 'backward' | 'left' | 'right' | 'tiltLeft' | 'tiltRight'
        // angle: number // 1 is full turn (360 degrees / 2PI radians)
        // duration: duration,
        // animate: animate
        let alpha = 0; // amount to turn
        let beta = 0;
        let gamma = 0;
        let axis;
        const angle = cmd.angle * Math.PI * 2; // angle of 1 is a full rotation
        switch (cmd.towards) {
            case 'right':
                axis = babylonjs_1.Vector3.Right();
                beta = angle;
                break;
            case 'left':
                axis = babylonjs_1.Vector3.Right();
                beta = -angle;
                break;
            case 'backward':
                axis = babylonjs_1.Vector3.Up();
                alpha = -angle;
                break;
            case 'forward':
                axis = babylonjs_1.Vector3.Up();
                alpha = angle;
                break;
            case 'tiltRight':
                axis = babylonjs_1.Vector3.Forward();
                gamma = -angle;
                break;
            case 'tiltLeft':
                axis = babylonjs_1.Vector3.Forward();
                gamma = angle;
                break;
            default:
                console.assert(false, `did not expect turn direction '${cmd.direction}'`);
        }
        let current;
        if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
            current = handle.babylonMesh.rotation.clone(); // clone() is VERY important
        }
        else {
            current = babylonjs_1.Vector3.Zero();
        }
        tween.start('turn', current, // start
        new babylonjs_1.Vector3(current.x + alpha, current.y + beta, current.z + gamma), // end
        cmd.timestamp, cmd.duration, cmd.animate, (value) => {
            if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                handle.babylonMesh.addRotation(value.x, 0, 0).addRotation(0, value.y, 0).addRotation(0, 0, value.z);
            }
            else {
                //TODO trn for camera
                console.error('Missing turn for camera');
            }
        });
    }
    moveAndTurn(cmd, tween, handle) {
        // direction: 'forward' | 'backward' | 'left' | 'right' | 'up' | 'down',
        // distance: number,
        // towards: 'forward' | 'backward' | 'left' | 'right' | 'tiltLeft' | 'tiltRight'
        // angle: number // 1 is full turn (360 degrees / 2PI radians)
        // duration: duration,
        // animate: animate
        // we create TWO tweens, but they are exactly the same length so
        // the turn one doesn't need a promise.  it's like:
        //  turn(somethiing).move(something)  [.done()]
        // the move part....
        const v = new babylonjs_1.Vector3(0, 0, 0);
        switch (cmd.direction) {
            case 'forward':
                v.z = cmd.distance;
                break;
            case 'backward':
                v.z = -cmd.distance;
                break;
            case 'left':
                v.x = -cmd.distance;
                break;
            case 'right':
                v.x = cmd.distance;
                break;
            case 'down':
                v.y = -cmd.distance;
                break;
            case 'up':
                v.y = cmd.distance;
                break;
            default:
                console.assert(false, `did not expect '${cmd.direction}'`);
        }
        // figure out where we would be by using a transform node
        const tNode = new babylonjs_4.TransformNode('', this.scene, false); // don't add to scene
        // set it to the same position and orientation as the mesh
        console.log('babylon mesh', handle.babylonMesh.position.clone());
        tNode.position = handle.babylonMesh.position.clone();
        tNode.locallyTranslate(v);
        tween.start('move', handle.babylonMesh.position.clone(), // start
        tNode.position.clone(), // end
        cmd.timestamp, cmd.duration, cmd.animate, (value) => {
            if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                handle.babylonMesh.translate(new babylonjs_1.Vector3(1, 0, 0), value.x, babylonjs_1.Space.WORLD);
                handle.babylonMesh.translate(new babylonjs_1.Vector3(0, 1, 0), value.y, babylonjs_1.Space.WORLD);
                handle.babylonMesh.translate(new babylonjs_1.Vector3(0, 0, 1), value.z, babylonjs_1.Space.WORLD);
            }
            else {
                console.error('missing move for camera');
            }
        });
        tNode.dispose();
        /// /////////////////////////
        // the turn part
        let alpha, beta, gamma;
        let axis;
        const angle = cmd.angle * Math.PI * 2;
        switch (cmd.towards) {
            case 'right':
                axis = babylonjs_1.Vector3.Right();
                beta = angle;
                break;
            case 'left':
                axis = babylonjs_1.Vector3.Right();
                beta = -angle;
                break;
            case 'backward':
                axis = babylonjs_1.Vector3.Up();
                alpha = -angle;
                break;
            case 'forward':
                axis = babylonjs_1.Vector3.Up();
                alpha = angle;
                break;
            case 'tiltRight':
                axis = babylonjs_1.Vector3.Forward();
                gamma = -angle;
                break;
            case 'tiltLeft':
                axis = babylonjs_1.Vector3.Forward();
                gamma = angle;
                break;
            default:
                console.assert(false, `did not expect '${cmd.direction}'`);
        }
        const turnTween = new tween_1.V3Tween('');
        let myRotation;
        if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
            myRotation = handle.babylonMesh.rotation;
        }
        else {
            myRotation = babylonjs_1.Vector3.Zero();
        }
        turnTween.start('turn', myRotation, // start
        new babylonjs_1.Vector3(alpha, beta, gamma), // end
        cmd.timestamp, cmd.duration, cmd.animate, (value) => {
            if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                handle.babylonMesh.addRotation(value.x, 0, 0).addRotation(0, value.y, 0).addRotation(0, 0, value.z);
            }
            else {
                // TODO: move and turn for camera
            }
        });
    }
    // turnToZero(cmd: gameCmd, tween: V3Tween, handle: MeshHandle) {
    //     const start = handle.babylonMesh.rotation // .getDirection(Vector3.Zero())  //new Vector3(0, 0, 0)
    //     // let start2 = handle.babylonMesh.getDirectionToRef()
    //     // let start3 = handle.babylonMesh.getDirectionToRef(Vector3.Zero())
    //     const end = Vector3.Zero()
    //     console.log('turnToZero', start, end)
    //     // let tNode = new TransformNode('', this.scene, false)  // don't add to scene
    //     // // // set it to the same position and orientation as the mesh
    //     // tNode.rotate(axis, angle, Space.LOCAL);
    //     this.turnSetupV3Tween(cmd, tween, handle, start, end)
    // }
    // // standard setup tween handler for all the 'turn' commands
    // turnSetupScalarTween(cmd: gameCmd, tween: ScalarTween, handle: MeshHandle, axis: Vector3, angle: number) {
    //     console.log('in turnSetupScalar', handle.babylonMesh.position, axis, angle)
    //     tween.start(
    //         'turn',
    //         0 /* start */,
    //         angle /* end */,
    //         cmd.timestamp,
    //         cmd.duration,
    //         cmd.animate,
    //         (value: number) => {
    //             handle.babylonMesh.rotate(axis, value, Space.LOCAL)
    //             const current = handle.babylonMesh.rotation
    //             const start1 = new Vector3(1, 0, 0)
    //             let start2: Vector3
    //             console.log('in turnSetupScalarStart()', handle.babylonMesh.position)
    //             // if(typeof handle.babylonMesh.position.x !== 'number')throw('stop!')
    //             // TODO: handle.babylonMesh.getDirectionToRef(start1, start2)
    //         })
    // }
    // standard setup tween handler for moveToZero,all the 'turn' commands
    turnSetupV3Tween(cmd, tween, handle, start, end) {
        tween.start('move', start /* start */, end /* end */, cmd.timestamp, cmd.duration, cmd.animate, (value) => {
            if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                handle.babylonMesh.addRotation(value.x, 0, 0).addRotation(0, value.y, 0).addRotation(0, 0, value.z);
            }
            else {
                // TODO: Rotation for camera?
            }
        });
    }
    size(cmd, tween, handle) {
        // x:scale3[0],
        // y:scale3[1],
        // z:scale3[2],
        // duration = 1,
        // animate: "Begin And End Normally" | "Begin Slow, End Fast" | "Begin Fast, End Slow" | "Begin And End Fast" | "Begin And End Slow" = "Begin And End Normally") {
        // we need to change the size AND move the mesh UP so feet stay in place
        if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
            const currentSize = handle.babylonMesh.scaling.clone();
            const futureSize = new babylonjs_1.Vector3(cmd.x, cmd.y, cmd.z);
            tween.start('size', currentSize /* start */, futureSize, /* end */ cmd.timestamp, cmd.duration, cmd.animate, (value) => {
                // console.log("size setting from", handle.babylonMesh.scaling, ' to ', value, ' with position ', handle.babylonMesh.position)
                if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                    handle.babylonMesh.scaling.x += /* future.x - */ value.x;
                    handle.babylonMesh.scaling.y += /* future.y - */ value.y;
                    handle.babylonMesh.scaling.z += /* future.z - */ value.z;
                }
                else
                    console.error('Scaling only for mesh');
            });
            // // now start the move
            // const moveCmd = Object.assign(cmd) // CLONE  // move uses the same timestamp, duration, animation, etc
            // moveCmd.action = 'move'
            // moveCmd.direction = 'up'
            // moveCmd.distance = (futureSize.y - currentSize.y) / 2 // get fancier later
            // this.processGameCmd(moveCmd)
        }
        else
            console.error('scaling only for mesh');
    }
    color(cmd, tween, handle) {
        // some materials don't accept color, but they are filtered out in processGameCmd()
        console.assert(cmd !== undefined, 'cmd missing');
        console.assert(tween !== undefined, 'tween missing');
        console.assert(handle !== undefined, 'handle missing');
        console.assert(handle.babylonMesh !== undefined, 'handle.babylonMesh missing');
        if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
            // use the V3Tween(x,y,z), just convert back and forth from Color3(r,g,b)
            // maybe changing the color?  update the name of this mesh with the new color
            handle.uniqueName = handle.babylonMesh.name = handle.model + '_' + handle.uuid + '_' + cmd.colorD;
            const currentColor = new babylonjs_1.Vector3(handle.babylonMesh.material['diffuseColor'].r, handle.babylonMesh.material['diffuseColor'].g, handle.babylonMesh.material['diffuseColor'].b);
            handle.diffuseColor = handle.babylonMesh.material['diffuseColor']; // for lines and stuff
            const colorD = utilities_1.HTMLColor(cmd.colorD); // 3 values between 0 and 1
            const futureColor = new babylonjs_1.Vector3(colorD.r, colorD.g, colorD.b);
            // console.log('%ccolor: current:', consoleRed, currentColor, ' future: ', futureColor)
            tween.start('color', currentColor.clone(), // start
            futureColor.clone(), // end
            cmd.timestamp, cmd.duration, cmd.animate, (value) => {
                if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                    const myMaterial = handle.babylonMesh.material;
                    myMaterial.diffuseColor = new babylonjs_1.Color3(Math.abs(myMaterial.diffuseColor.r) + value.x, Math.abs(myMaterial.diffuseColor.g) + value.y, Math.abs(myMaterial.diffuseColor.b) + value.z);
                    handle.diffuseColor = handle.babylonMesh.material['diffuseColor']; // for lines and stuff
                }
            });
        }
        else
            console.error('color only for mesh');
    }
    opacity(cmd, tween, handle) {
        console.assert(handle.babylonMesh instanceof babylonjs_1.Mesh);
        if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
            tween.start('opacity', handle.babylonMesh.material.alpha, // start
            cmd.opacity, // end
            cmd.timestamp, cmd.duration, cmd.animate, (value) => {
                if (handle.babylonMesh instanceof babylonjs_1.Mesh) { // typeguard
                    const myMaterial = handle.babylonMesh.material;
                    myMaterial.alpha = Math.abs(myMaterial.alpha) + value;
                    handle.opacity = myMaterial.alpha; // in case we have a line or similar
                }
            });
        }
        else
            console.error('Opacity only on mesh');
    }
    animatedGif(cmd, tween, handle) {
        // don't care whether this is a mesh or not
        tween.start('misc', 0, // start
        1, // start and end don't mean anything here
        cmd.timestamp, cmd.duration, cmd.animate, (value) => {
            babylonjs_5.Tools.CreateScreenshot(this.engine, this.camera, cmd.resolution);
        });
    }
    break(cmd, handle) {
        // step 1 - reset times, so tween is 'expired'
        handle.tweenArray.forEach((tween) => {
            // TODO: should only delete 'moves'.  or use cmd.?? to specify which
            tween.isCancelled = true;
        });
        // step 2 - resolve expired tweens and delete
        handle.tweenArray.forEach((tween, index, tweenArray) => {
            if (tween.isCancelled) { // don't use 'expired' because it moves the shape
                // might not be a promise, if no 'await' / done()
                console.assert(typeof tween.promiseResolve === 'function');
                // console.log("%cResolving a promise", consoleRed)
                tween.promiseResolve(); // complete the promise
                tweenArray.splice(index, 1); // and delete the tween
            }
        });
    }
    createGUI(cmd, handle) {
        handle.babylonRectangle = babylonjs_gui_1.Button.CreateSimpleButton('', 'uninitialized button');
        // defaults...
        handle.babylonRectangle.width = '100px';
        handle.babylonRectangle.height = "40px";
        handle.babylonRectangle.cornerRadius = 5;
        handle.babylonRectangle.color = "#fff";
        handle.babylonRectangle.thickness = 1;
        handle.babylonRectangle.background = '#007bff';
        handle.fontsize = 18; // for calculations
        handle.babylonRectangle.fontSize = "18px";
        handle.babylonRectangle.onPointerDownObservable.add(() => {
            handle.babyShape.onPressDown(this.playerNumber);
        });
        this.advancedTexture.addControl(handle.babylonRectangle);
    }
    textGUI(cmd, handle) {
        const textBlock = new babylonjs_gui_1.TextBlock('', cmd.text);
        handle.babylonRectangle.clearControls();
        handle.babylonRectangle.addControl(textBlock);
        if (cmd.resize) {
            const textsize = utilities_1.measureText(cmd.text, cmd.fontsize) + 30;
            handle.babylonRectangle.width = `${textsize}px`;
        }
    }
    colorGUI(cmd, handle) {
        handle.babylonRectangle.color = cmd.color;
        handle.babylonRectangle.background = cmd.background;
        handle.babylonRectangle.thickness = 1;
    }
    positionGUI(cmd, handle) {
        if (cmd.leftRight == 1)
            handle.babylonRectangle.horizontalAlignment = babylonjs_gui_1.Control.HORIZONTAL_ALIGNMENT_RIGHT;
        if (cmd.leftRight == -1)
            handle.babylonRectangle.horizontalAlignment = babylonjs_gui_1.Control.HORIZONTAL_ALIGNMENT_LEFT;
        if (cmd.topBottom == 1)
            handle.babylonRectangle.verticalAlignment = babylonjs_gui_1.Control.VERTICAL_ALIGNMENT_TOP;
        if (cmd.topBottom == -1)
            handle.babylonRectangle.verticalAlignment = babylonjs_gui_1.Control.VERTICAL_ALIGNMENT_BOTTOM;
    }
    resizeGUI(cmd, handle) {
        handle.babylonRectangle.width = '100px';
        handle.babylonRectangle.height = "40px";
        handle.babylonRectangle.cornerRadius = 5;
        handle.babylonRectangle.color = cmd.color;
        handle.babylonRectangle.thickness = 1;
        handle.babylonRectangle.background = cmd.background;
    }
    // other things we can do...
    // a.alpha = .5
    // // a.top = 20  // move it DOWN 20 px
    /** can't resize an impostor, so drop it and recreate  */
    recreatePhysicsImpostor(handle) {
        // obvously only for meshes, but Typescript needs a typeguard
        if (handle.babylonMesh instanceof babylonjs_1.Mesh) {
        }
    }
    // turn the inspector on or off
    inspector(cmd) {
        if (!this.scene.debugLayer.isVisible()) {
            this.scene.debugLayer.show();
        }
        if (cmd.stringParm == 'record') {
            if (babylonjs_5.VideoRecorder.IsSupported(this.engine)) {
                var recorder = new babylonjs_5.VideoRecorder(this.engine);
                recorder.startRecording();
            }
        }
    }
    /////////// dynamic textures ////////////
    setTexture(cmd, handle) {
        // the programmer used 'getContext()' to get his shape context, 
        // but we don't trust that for remote players.  
        // let newFn = new Function(`let uuid = ${handle.uuid}; return `+  cmd.ctxFunction)
        // console.log(newFn.toString())
        // let a = newFn()
        // a()
        if (handle.dynamicTexture === undefined) {
            handle.material.diffuseTexture = handle.dynamicTexture;
        }
        handle.material.diffuseTexture = handle.dynamicTexture;
        let evalFn = `let uuid = ${handle.uuid}; 
                let resolution = 1024  // hard coded

                // // width,height,context are captured from the shape...
                // let width = handle.dynamicTexture.getSize().width * resolution;
                // let height = handle.dynamicTexture.getSize().height * resolution;
                let ctx = handle.dynamicTexture.getContext();

                // passed in stringify, so serialized for remotes
                let params = JSON.parse('${cmd.params}')
                let x = ${cmd.ctxFunction}; 
                x();`;
        // console.log('about to run ', evalFn)
        eval(evalFn);
        handle.dynamicTexture.update();
    }
    //////////////// vt52 ///////////////
    print(cmd, handle) {
        handle.thing['print'](cmd.text, cmd.color);
    }
    // full refresh of screen.
    drawScreen(handle) {
        handle.thing['drawScreen']();
        return;
    }
    ////////////// we create lines with penUp, penDown, and lineErase
    penUp(cmd, handle) {
        handle.isPenDown = false;
        handle.lastPosition = null;
    }
    penDown(cmd, handle) {
        handle.isPenDown = true;
        handle.radius = cmd.radius;
        handle.lastPosition = handle.getPosition();
    }
    lineErase(cmd, handle) {
        handle.isPenDown = false;
        handle.lineArray.forEach(element => { element.dispose(); });
        handle.lastPosition = null;
    }
    // close the entire game down
    gameDispose() {
        this.scene.dispose();
    }
    ////////////////////////////////////////
    ///////// some 2D graph commands  //////
    ////////////////////////////////////////
    drawGrid(cmd, handle) {
        handle.thing['drawGrid'](cmd.x, cmd.y);
    }
    drawLine(cmd, handle) {
        handle.thing['drawLine'](cmd.marker, cmd.x, cmd.y, cmd.rest);
    }
    drawCircle(cmd, handle) {
        handle.thing['drawCircle']([cmd.x, cmd.y], cmd.radius);
    }
    drawRect(cmd, handle) {
        handle.thing['drawRect']([cmd.x, cmd.y], [cmd.dx, cmd.dy]);
    }
    textAt(cmd, handle) {
        handle.thing['textAt'](cmd.text, cmd.x, cmd.y, cmd.dx, cmd.dy);
    }
    runRenderStep() {
        // run all the tweens (delete some that have expired)
        babyengine_1.BabyEngine.processTweens();
        // and run the physics engine too
        this.runPhysicsStep();
        // if the game doesn't define a camera, we need to do it ourselves
        // (of course, the game might not have gotten that far)
        // worst case, this camera will hang around unused.
        if (!this.isCameraSet) {
            // console.log('%c adding a arcRotate, because programmer did not', consoleRed)
            const newE = new babything_1.BabyCamera('camera', this.babyEngine); // creates the game-writer's object
            const handle = babyengine_1.BabyEngine.shapeMap.get(newE.uuid);
            // just call it directly, other players will do the same
            let t = new things_1.CameraThing({ uuid: handle.uuid, action: 'setCamera', model: 'arcRotate' }, handle, this.scene);
            this.activeCameraHandle = handle; // it's now the active one
            this.isCameraSet = true;
        }
        for (;;) { // infinite loop, maybe an exit one day??
            babyengine_1.BabyEngine.notifyObservers(`tick`); // anyone subscribing to 'tick' ??
            this.scene.render(); // finally, render the scene, and loop around
            requestAnimationFrame(this.runRenderStep.bind(this));
            return (this);
        }
    }
    runPhysicsStep() {
        console.assert(Array.isArray(babyengine_1.BabyEngine.impostors), 'probably started babylon before initializing BabyEngine');
        // two steps of 120th is more accurate than one step of 60th
        this.physicsPlugin.executeStep(1 / 120, babyengine_1.BabyEngine.impostors);
        this.physicsPlugin.executeStep(1 / 120, babyengine_1.BabyEngine.impostors);
    }
}
exports.Babylon = Babylon;
//# sourceMappingURL=babylon.js.map