import { Baby } from './baby';
import { BabyThing, BabyShape } from "./babything";
import { BabyEngine } from '../middle/babyengine';
export declare class BabyCamera extends BabyThing {
    constructor(model: string, baby: Baby, babyEngine: BabyEngine);
    /** A 'camera' defines the player, a multi-player game may have multiple cameras. */
    control(cameraType: 'universal' | 'arcRotate' | 'follow' | 'fly'): void;
    /**  Move an entity  */
    move(direction: 'forward' | 'backward' | 'left' | 'right' | 'up' | 'down', distance: number, duration?: number, animate?: '1-Begin And End Normally' | '2-Begin Slow, End Fast' | '3-Begin Fast, End Slow' | '4-Begin And End Fast' | '5-Begin And End Slow'): BabyCamera;
    /**  MoveToward- moves towards another shape.  Often getDistanceTo(other) is useful.  */
    moveToward(other: BabyShape, distance: number, duration?: number, animate?: '1-Begin And End Normally' | '2-Begin Slow, End Fast' | '3-Begin Fast, End Slow' | '4-Begin And End Fast' | '5-Begin And End Slow'): BabyCamera;
    moveToZero(duration?: number, animate?: '1-Begin And End Normally' | '2-Begin Slow, End Fast' | '3-Begin Fast, End Slow' | '4-Begin And End Fast' | '5-Begin And End Slow'): BabyCamera;
}
