export declare type Action<T> = {
    type: string;
    payload: any;
};
export declare type Subscriber<T> = (state: T) => void;
export declare type Reducer<T> = (state: T, action: Action<T>) => T;
export declare function createStore<T>(reducer: Reducer<T>, initialState?: T): {
    getState: () => T;
    dispatch: (action: Action<T>) => void;
    subscribe: (fn: Subscriber<T>) => () => Subscriber<T>[];
};
export declare function testRedux(): void;
