"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Remote = void 0;
const Ably = __importStar(require("ably"));
class Remote {
    // // get the Ably key
    // BabyEngine.getEnv()  // this doesn't happen right away 
    // two channels - 
    // gameroom               // server
    // gameroomRemote         // remote players  
    constructor(playerRole) {
        this.ablyKey = 'Ui15tQ.PluWTw:1AblFCqygSLQAPwl';
        this.playerUuidList = []; // only use this if we are the server
        this.playerRole = playerRole;
        this.playerUuid = window.performance.now();
        if (this.playerRole == 'singlePlayer') {
            // nothing to do
        }
        if (this.playerRole == 'server') {
            // set up a connection to Ably, good for the rest of the game
            this.connectAbly(this.ablyKey);
            // we need to host the gameroom and provide tokens
            // just in case we are playing too, we add ourselves as the first player
            this.playerUuidList.push(this.playerUuid);
            this.playerNumber = this.playerUuidList.length; // should be 1 cuz we are first
            console.log(`We are PLAYER${this.playerNumber}`);
            // set up a subscriber to catch any 'let me play' requests (gameRoomHost)
            let ablyChannel = this.ably.channels.get('gameroom');
            ablyChannel.subscribe((received) => this.gameRoomHost(this, received));
            console.log('setting up the gameroom host');
        }
        if (this.playerRole == 'playerN') {
            // set up a connection to Ably, good for the rest of the game
            this.connectAbly(this.ablyKey);
            // we need to introduce ourself and ask for a game token
            // set up a subscriber to catch the answer
            let ablyChannel = this.ably.channels.get('gameroom');
            ablyChannel.subscribe((received) => this.remotePlayer(this, received));
            console.log('setting up the remote player host');
            // and sent out a request for a game token
            this.publishAbly('gameroom', 'G01&' + this.playerUuid.toString());
            console.log('requesting a game token');
        }
    }
    //////////////////////////
    /// don't know if it's a bug in Ably, but can't access 'this'.
    /// so we send the Remote object as the first param for each listener
    /// use remote.thing  instead of   this.thing
    //////////////////////////
    gameRoomHost(remote, received) {
        console.log('in Remote.gameRoomHost(), got message', received.data);
        let data = JSON.parse(received.data).split('&');
        console.log(data);
        switch (data[0]) {
            case 'G01': // introduction, sent us a microtime uuid
                console.log('in G01');
                remote.playerUuidList.push(data[1]);
                console.log('have pushed');
                remote.playerNumber = remote.playerUuidList.length; // should be 1 cuz we are first
                console.log(`just set player ${remote.playerNumber}`);
                remote.publishAbly('gameroom', 'G02&' + remote.playerUuidList[remote.playerUuidList.length - 1].toString() + '&' + remote.playerNumber.toString());
                console.log(`have added Player${remote.playerNumber}`);
                break;
            default: // everything else can be ignored
        }
    }
    remotePlayer(remote, received) {
        console.log('in Remote.remotePlayer, got raw message', received.data);
        let data = JSON.parse(received.data).split('&');
        console.log('in Remote.remotePlayer, got message', data);
        switch (data[0]) {
            case 'G02': // we are given our player number
                console.log('playerUuid', remote.playerUuid.toString());
                if (data[1] == remote.playerUuid.toString()) { // if this message is for us
                    remote.playerNumber = data[2];
                    console.log(`We are PLAYER${remote.playerNumber}`);
                }
                else {
                    console.log('message not for us', data[1], remote.playerUuid.toString);
                }
                break;
            default: // everything else can be ignored
        }
    }
    connectAbly(secretKey) {
        this.ably = new Ably.Realtime(secretKey);
        this.ably.connection.on('connected', function () {
            console.log("That was simple, you're now connected to Ably in realtime");
        });
    }
    subscribeAbly(channel) {
        var ablyChannel = this.ably.channels.get(channel);
        ablyChannel.subscribe(channel, function (recieved) {
            let message = JSON.parse(recieved.data); // it's always a string anyhow
            console.log("Received a greeting message in realtime: " + message.data);
        });
    }
    publishAbly(channel, message) {
        var ablyChannel = this.ably.channels.get(channel);
        console.log('sending a message to Ably');
        ablyChannel.publish(channel, JSON.stringify(message));
    }
}
exports.Remote = Remote;
//# sourceMappingURL=remote.js.map