import { Observers } from '../middle/babyengine';
/** This is the factory, use the concrete classes below (like VT52) */
export declare abstract class World {
    height: number;
    width: number;
    canvas: HTMLCanvasElement;
    ctx: CanvasRenderingContext2D;
    observer: Observers;
    constructor();
}
/** An old-fashioned cathod-ray-terminal (CRT), like the legendary DEC VT52 */
export declare class VT52 extends World {
    displayBuffer: number[];
    cursorX: number;
    cursorY: number;
    pressedKeyBuffer: number[];
    constructor();
    testVT52(): void;
    processVT52Key(event: KeyboardEvent): void;
    drawScreen(): void;
    printString(chars: string): void;
    printChar(charCode: number): void;
    printCRLF(): void;
}
